#! /bin/bash

clear
chemin=`pwd`

echo " PROGRAMME CHOLESKY - RESOLUTION DU SYSTEME Ax=B par la methode de Cholesky"
echo " **************************************************************************"
echo " Entrer le fichier de la matrice A :"
read matA


if test -f $matA 
    then

    tailleMATRICEA=`head -1 $matA | cut -f1 -d\ `

    nbElemDeA=`head -1 $matA | cut -f3 -d\ `
    nbligneFicA=`wc -l  $matA | cut -f1 -d\ `
    
    # On enleve la ligne de définition de la matrice
    nbligneFicA=` expr  $nbligneFicA - 1 `

    if  [ $tailleMATRICEA = 0 ]
	then
	echo " Le fichier est vide" >&2
        exit 1
    fi

    echo "Le nombre d'element de A est de   $nbligneFicA"
    if  [ $nbElemDeA -ne $nbligneFicA ]
	then
	echo " Le fichier n'a pas le nombre d'element defini" >&2
        exit 1
    fi
    


    echo "Entrer le fichier de la matrice B : (tapez \'rien\' sinon)"
    read matB

    if  test -f  $matB
	then
	tailleMATRICEB=`wc -l $matB | cut -f1 -d\ `
       


	echo "MATRICE DE TAILLE $tailleMATRICEA  $tailleMATRICEA"

	if  [ $tailleMATRICEB -ne  $tailleMATRICEA ]
	    then
	      echo " Le fichier est vide" >&2
	      echo " CREATION D'UN FICHIER RESULTAT QUI SERA REMPLIT PAR +/- 1/RACINE(TAILLE)"
	      gcc -o genererElement genererElement.c -lm
	      ./genererElement $tailleMATRICEA > $chemin/b.txt
	      matB=$chemin/b.txt;
	fi
    else
	      echo " Le fichier n'existe pas" >&2
	      echo " CREATION D'UN FICHIER RESULTAT QUI SERA REMPLIT PAR +/- 1/RACINE(TAILLE)"
	      gcc -o genererElement genererElement.c -lm
	      ./genererElement $tailleMATRICEA > $chemin/b.txt
	      matB=$chemin/b.txt;
    fi




    g77 -o CNcholesky2 CNcholesky2.f
    cat $matA $matB > $chemin/tmp.txt


    echo "Voulez vous stocker le resultat dans un fichier resultat.txt? [y/Y/o/O/n/N]"
    read choix

    case $choix in
       'y')./CNcholesky2 < $chemin/tmp.txt > resultat.txt;;
      'Y')./CNcholesky2 < $chemin/tmp.txt > resultat.txt;;
       'o')./CNcholesky2 < $chemin/tmp.txt > resultat.txt;;
       'O')./CNcholesky2 < $chemin/tmp.txt > resultat.txt;;
       *)./CNcholesky2 < $chemin/tmp.txt;;
       esac


else
	echo "Le fichier $matA n'existe pas" >&2
	exit 1
    


fi


